{*******************************************************************************
  HiAsm stamp component builder v0.8 (autor - andrestudio)
  Component - DumpDebug
  Version - 1.0
  Autor - andrestudio
  E-mail -   :)
  Create - , 22.  2018, 00:34:12
  Description:      ,    .
      TMashaDebug    www.delphiday.blogspot.com
*******************************************************************************}

unit hiDumpDebug;

interface

uses Windows,Kol,Share,debug;

type
  TRegs = array [0..7] of DWORD;
  TMashaDebug = class
    private
        FStackFlow:PstrList;
        FStack:PstrList;
        FRegisters:TRegs;
        FDump:String;
        procedure GetTextDump(pData:Pointer; dDumpSize:DWORD);
        procedure GetStackFlow(dStackSize:DWORD);
        function  GetStackValue(pESP:DWORD):DWORD;stdcall;
        procedure GetRegisters(var Regs:TRegs);
    public
        constructor Create(pData:Pointer; dDumpSize,dStackSize:DWORD);
        destructor  Destroy; override;
        procedure   SaveToFile(Filename:String); virtual;
        procedure   TakeScreenShot(Filename:String); virtual;
        property    Stack:PStrList read FStack;
        property    Dump:String read FDump;
        property    Registers:TRegs read FRegisters;
  end;

type
 THIDumpDebug = class(TDebug)
   private
     FLstRegisters: PStrList;
     FDumpSize,FStackSize: dword;
   { Var methods variable }
     {       }
     vStack : string;
     {     Stream }
     vDump: string;
     {    }
     vRegisters: string;

   { Property variable  }
     {            }
     fFileNameDump: string;
     {       (screenshot) }
     fFileNameScr: string;

     fLogFile: boolean;
     fScreen: boolean;
   public
     Debug: TMashaDebug;
     {      }
     _prop_DumpSize: integer;
     {       }
     _prop_StackSize: integer;



   { Event points }
     _event_onStack: THI_Event;
     _event_onDump: THI_Event;
     _event_onRegisters: THI_Event;

   { Data points}
     {        }
     _data_Stream: THI_Event;
     {      }
     _data_DumpSize: THI_Event;
     {       }
     _data_StackSize: THI_Event;

     {       (screenshot) }
     _data_FileNameScr: THI_Event;
     {            }
     _data_FileNameDump: THI_Event;

     constructor Create;
     destructor Destroy; override;

   { Events }
     {     doDebug     
       }
     procedure onStack;
     {     doDebug    Stream
         }
     procedure onDump;
     {      doDebug  
         }
     procedure onRegisters;

   { Methods }
     {    ,     }
     procedure _work_doDebug(var _Data: TData; Index: Word);


   { Methods from property }

   { Var procedure }
     {       }
     procedure _var_Stack (var _Data: TData; Index: Word);
     {    Stream }
     procedure _var_Dump(var _Data: TData; Index: Word);
     {        | }
     procedure _var_Registers(var _Data: TData; Index: Word);

   { Property }
     {            }
     property _prop_FileNameDump: string  read fFileNameDump  write fFileNameDump;
     {       (screenshot) }
     property _prop_FileNameScr: string  read fFileNameScr  write fFileNameScr;
     {    }
     property _prop_LogFile: boolean  read fLogFile  write fLogFile;
     {    }
     property _prop_Screen: boolean  read fScreen  write fScreen;

  end;

implementation

constructor THIDumpDebug.Create;
begin
  inherited Create;
  FLstRegisters := NewStrList;
end;

destructor THIDumpDebug.Destroy;
begin
  FLstRegisters.Free;
  inherited Destroy;
end;


{     doDebug      
 }
procedure THIDumpDebug.onStack;
begin
  _hi_onEvent(_event_onStack,vStack);
end;

{     doDebug      
  }
procedure THIDumpDebug.onDump;
begin
  _hi_onEvent(_event_onDump,vDump);
end;

{      doDebug  
      }
procedure THIDumpDebug.onRegisters;
begin
  _hi_onEvent(_event_onRegisters,vRegisters);
end;

{    ,     }
procedure THIDumpDebug._work_doDebug;
var
  i: Integer;
  p: PStream;
begin
  p := ToStreamEvent(_data_Stream);
  FDumpSize := ReadInteger(_Data,_data_DumpSize,_prop_DumpSize);
  FStackSize := ReadInteger(_Data,_data_StackSize,_prop_StackSize);
  Debug := TMashaDebug.Create(p.Memory,FDumpSize,FStackSize);

  try

    vStack := Debug.Stack.Text; onStack;

    FLstRegisters.add('EAX: '+Int2Hex(Debug.Registers[0],8));
    FLstRegisters.add('EBX: '+Int2Hex(Debug.Registers[1],8));
    FLstRegisters.add('ECX: '+Int2Hex(Debug.Registers[2],8));
    FLstRegisters.add('EDX: '+Int2Hex(Debug.Registers[3],8));
    FLstRegisters.add('ESI: '+Int2Hex(Debug.Registers[4],8));
    FLstRegisters.add('EDI: '+Int2Hex(Debug.Registers[5],8));
    FLstRegisters.add('EBP: '+Int2Hex(Debug.Registers[6],8));
    FLstRegisters.add('ESP: '+Int2Hex(Debug.Registers[7],8));

    vRegisters := FLstRegisters.Text; onRegisters;
    vDump := Debug.Dump; onDump;

    if _prop_LogFile then
      Debug.SaveToFile(_prop_FileNameDump);

    if _prop_Screen then
      Debug.TakeScreenShot(_prop_FileNameScr);

  finally
    Debug.Free;
  end;
  FLstRegisters.Clear;
end;


{       }
procedure THIDumpDebug._var_Stack ;
begin
  dtString(_Data, vStack);
end;

{     doDebug    Stream
    }
procedure THIDumpDebug._var_Dump;
begin
  dtString(_Data, vDump);
end;

{         }
procedure THIDumpDebug._var_Registers;
begin
  dtString(_Data, vRegisters);
end;

constructor TMashaDebug.Create(pData:Pointer; dDumpSize,dStackSize:DWORD);
begin
  FDump :='';
  FStack := NewStrlist;
  Self.GetTextDump(pData,dDumpSize);
  Self.GetStackFlow(dStackSize);
  Self.GetRegisters(FRegisters);
end;

destructor TMashaDebug.Destroy;
begin
  FDump := '';
  {$ifdef F_P}
  FStack.Clear;
  {$else}
  FStack.Free;
  {$endif}
  inherited Destroy;
end;

function TMashaDebug.GetStackValue(pESP: DWORD): DWORD; stdcall;
asm
  mov edx,esp
  mov esp,pESP
  pop eax
  mov esp,edx
end;

procedure TMashaDebug.GetRegisters(var Regs:TRegs);
asm
  mov [Regs],eax
  mov [Regs+4],ebx
  mov [Regs+8],ecx
  mov [Regs+12],edx
  mov [Regs+16],esi
  mov [Regs+20],edi
  mov [Regs+24],ebp
  mov [Regs+28],esp
end;

procedure TMashaDebug.GetStackFlow(dStackSize: DWORD);
var
  dESP:DWORD;
  i: Integer;
  arStack:array of DWORD;
begin
  SetLength(arStack,dStackSize);
  asm
    mov dESP,esp
  end;
  for i := 0 to High(arStack)-1 do
    begin
      arStack[i] := GetStackValue(dESP);
      dESP:=dESP-SizeOf(DWORD);
    end;
  dESP:=dESP+(SizeOf(DWORD)*dStackSize-SizeOf(DWORD));
  FStackFlow := NewStrlist;
  try
    for i := 0 to High(arStack) - 1 do
      begin
        FStackFlow.Add('ESP: '+Int2Hex(dESP,8)+' '+Int2Hex(arStack[i],8));
        dESP := dESP-SizeOf(DWORD);
      end;
    FStack.Assign(FStackFlow);
  finally
    FStackFlow.Free;
  end;
  arStack := nil;
end;

procedure TMashaDebug.GetTextDump(pData:Pointer; dDumpSize:DWORD);
var
  i,j,k,t:DWORD;
  arr1:string;
  arr2:string;
begin
  k := 0;
  j := 0;
  t := 0;
  i := 0;
  arr1 := '0x00000000: | ';
  while i <> dDumpSize do
    begin
      if j = 4 then
        begin
         arr1 := arr1+' | ';
         j := 0;
        end
      else
      if (k = 16)  then
        begin
         arr1 := arr1+arr2;
         t := t+16;
         arr1 := arr1+#13#10+'0x'+Int2Hex(t,8)+': | ';
         k := 0;
         arr2 :='';
        end
      else
      begin
         arr1 := arr1 + Int2Hex(Byte(pData^),2)+' ';
         case Chr(Byte(pData^)) of
           #0  : arr2 := arr2+' ';
           #10 : arr2 := arr2+#127;
           #09 : arr2 := arr2+#127;
           #13 : arr2 := arr2+#127;
         else
          arr2 := arr2 + Chr(Byte(pData^));
         end;
        inc(DWORD(pData));
        inc(j);
        inc(k);
        inc(i);
       end;
    end;
    if j = 4 then arr1:=arr1+' | ';
    j := 16-k;
    for i := 1 to j do
      if (i+k) mod 4 = 0 then
        arr1:=arr1+'    | '
      else
        arr1:=arr1+'   ';
  arr1:=arr1+arr2;
  FDump := arr1;
end;

procedure TMashaDebug.SaveToFile(Filename: String);
var
  fStrings:PStream;
begin
  fStrings := NewWriteFileStream(Filename);
  try
    fStrings.WriteStr('Dump:'+#13+#10);
    fStrings.WriteStr(FDump+#13+#10);
    fStrings.WriteStr('Stack:'+#13+#10);
    fStrings.WriteStr(FStack.Text);
    //fStrings.SaveToFile(filename);
    CloseFileStream(fStrings);
  finally
    fStrings.Free;
  end;
end;

procedure TMashaDebug.TakeScreenShot(Filename: String);
var
  bmp: Kol.PBitmap;
  DC: HDC;
begin
  bmp := NewBitmap(0,0);
    try
      bmp.Height := ScreenHeight;
      bmp.Width := ScreenWidth;
      DC := GetDC(0);
      bitblt(bmp.Canvas.Handle, 0, 0, ScreenWidth, ScreenHeight,DC, 0, 0, SRCCOPY);
      bmp.SaveToFile(Filename);
      ReleaseDC(0, DC);
    finally
      bmp.Free;
    end;
end;

end.
